# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2010 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License                *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#*************************************************************************** 

from frmconfinicial import *
from PyQt4 import QtCore, QtGui

#class Ui_frmconfinicial2(Ui_frmconfinicial):
	#def next(self):
		#print "siguiente"


class confinicial(QtGui.QWizard):

	def __init__(self, parent=None):
			
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_frmconfinicial()
		self.ui.setupUi(self)
		#conectores
		self.connect(self.ui.chkLicencia,QtCore.SIGNAL("clicked()"),self.chkLicenciaChange)
		self.connect(self.ui.btnProbar,QtCore.SIGNAL("clicked()"),self.btnProbarClick)
		self.connect(self,QtCore.SIGNAL("currentIdChanged(int)"),self.next)

		self.ui.next = self.next

	def __tr(self,s,c = None):
		return qApp.translate("frmconfinicial",s,c)

	def next(self):
		print "siguiente"
		print self.currentPage().objectName()
		
		if self.currentPage().objectName() == "WizardPage":
			
			# Del 1 al 2
			
			if self.ui.chkLicencia.checkState()==1:
				self.ui.CargaIdiomas()
				self.showPage(self.ui.WizardPage_2)
			return
		if self.currentPage().objectName() == "WizardPage_2":
			
			# Del 2 al 3
			# Actualizamos el idioma
			
			self.AplicaIdioma()
			
			self.showPage(self.ui.WizardPage_3)
			print self.frmParent.conf.LeeConfiguracion('dbtype')
			if (self.frmParent.conf.LeeConfiguracion('dbtype') == 'mysql'):
				self.ui.radSQLite.setOn(0)
				self.ui.radMySQL.setOn(1)
			
			
			
			return
		if self.currentPage().objectName() == "WizardPage_3":
			
			# Del 3 al 4 ó 5
			
			if self.ui.radSQLite.isOn():
				if self.CompruebaSQLite():
					#Mostramos el último
					
					self.loadFinishEvent()
					self.showPage(self.ui.WizardPage_5)
					self.setFinishEnabled(self.ui.WizardPage_5,1)
			else:
				if self.CompruebaMySQLdb():
					#Mostramos la configuración de MySQL
					self.showPage(self.ui.WizardPage_4)
					
					self.ui.txtHost.setText(self.frmParent.conf.LeeConfiguracion('host'))
					self.ui.txtUser.setText(self.frmParent.conf.LeeConfiguracion('user'))
					self.ui.txtPassword.setText(self.frmParent.conf.LeeConfiguracion('pass'))
					self.ui.txtDbname.setText(self.frmParent.conf.LeeConfiguracion('dbname'))
					
			return
		if self.currentPage().objectName() == "WizardPage_4":
			
			# Del 4 al 5
			
			if self.CompruebaConexionMySQL():
				self.loadFinishEvent()
				self.showPage(self.ui.WizardPage_5)
				self.setFinishEnabled(self.ui.WizardPage_5,1)
			return

	def back(self):
		
		print self.currentPage().objectName()
		
		if self.currentPage().objectName() == "WizardPage_5":
			if self.ui.radSQLite.isOn():
				self.showPage(self.ui.WizardPage_3)
			else:
				self.showPage(self.ui.WizardPage_4)
			return
		if self.currentPage().objectName() == "WizardPage_4":
			self.showPage(self.ui.WizardPage_3)
			return
		if self.currentPage().objectName() == "WizardPage_3":
			self.showPage(self.ui.WizardPage_2)
			return
		if self.currentPage().objectName() == "WizardPage_2":
			self.showPage(self.ui.WizardPage)
			return

	def chkLicenciaChange(self):
		#Si no ha checkeado, no le dejamos seguir
		if self.ui.chkLicencia.checkState()==1:
			self.setNextEnabled(self.ui.WizardPage,1)
		else:
			self.setNextEnabled(self.ui.WizardPage,0)
		
	def CompruebaMySQLdb(self):
		
		try:
			import MySQLdb
			print "MySQLdb cargada correctamente."
			return 1
		except ImportError:
			QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensión MySQL. Compruebe que esta instalado el paquete python-mysqldb"))
			return 0
		
	def CompruebaSQLite(self):
		
		try:
				
			try: 
				import sqlite3 as dbapi
			except ImportError:
				from pysqlite2 import dbapi2 as dbapi
			
			print "SQLite cargado"
			return 1
		except:
			QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensión SQLlite."))
			return 0
		
	def btnProbarClick(self):
		if (self.CompruebaConexionMySQL() and self.correctdbname):
			QMessageBox.information(self,"sMovieDB - Información",self.__tr("Conexión establecida correctamente."))
		
	def CompruebaConexionMySQL(self):
		
		try:
			import MySQLdb
			self.db = MySQLdb.connect(host=str(self.ui.txtHost.text()),user=str(self.ui.txtUser.text()),passwd=str(self.ui.txtPassword.text()),db='')
			self.dbconn = self.db.cursor()
			try:
				self.dbconn.execute("USE "+str(self.txtDbname.text()))
				self.correctdbname = 1
			except:
				QMessageBox.information(self,"sMovieDB - Información",self.__tr("La conexión se ha establecido correctamente pero\nla base de datos <<"+str(self.ui.txtDbname.text())+">> parece no existir. Se intentará crear con una estructura inicial."))
				self.correctdbname = 0
			#self.db.close()
			return 1
		except:
			QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo conectar con el servidor MySQL con los datos facilitados.\nCompruebe que todos los datos son correctos"))
		return 0

	def CargaIdiomas(self):
		
		print "Detectando idiomas..."
		self.dirname = "./langs"
		
		#self.ddlIdioma.insertItem("")
		for f in os.listdir(self.dirname):
			fichero = os.path.join(self.dirname, f)
			if (os.path.isfile(fichero) and f[-2:]=="qm"):
				self.ui.ddlIdioma.insertItem(f[:-3])
		return
	
	def AplicaIdioma(self):
		translator = QTranslator(qApp)
		a=translator.load(self.dirname+"/"+str(self.ui.ddlIdioma.currentText())+".qm")
		
		if a==0:
			QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al cargar el idioma'))
			print "No translation for "+self.ui.ddlIdioma.currentText()+"\nNo se encuentra el idioma "+self.ui.ddlIdioma.currentText()
		else:
			qApp.installTranslator(translator)
			self.nextButton().setText(self.__tr("Siguiente >"))
			self.backButton().setText(self.__tr("< Atrás"))
			self.cancelButton().setText(self.__tr("Cancelar"))
			self.finishButton().setText(self.__tr("Finalizar"))
			self.languageChange()
			
			#self.frmParent.languageChange()
			
	def loadFinishEvent(self):
		#Asociamos el evento clicked del botón finalizar a la función self.Finalizar
		self.connect(self.finishButton(),QtCore.SIGNAL("clicked()"),self.Finalizar)
		return

	def Finalizar(self):
		print "Aplicamos todas las configuraciones"
		
		#Aplicamos el idioma
		self.frmParent.languageChange()
		idioma = self.ui.ddlIdioma.currentText()
		
		
		#Datos de BD
		tipobd=''
		dbname=''
		if self.ui.radSQLite.isOn():
			tipobd = 'sqlite'
			host = ''
			user = ''
			passw = ''
			dbname = ''
			self.correctdbname = 0
		else:
			tipobd = 'mysql'
			host = self.ui.txtHost.text()
			user = self.ui.txtUser.text()
			passw = self.ui.txtPassword.text()
			dbname = self.ui.txtDbname.text()
			
		self.frmParent.conf.GuardaConfiguracion('host', host)
		self.frmParent.conf.GuardaConfiguracion('user', user)
		self.frmParent.conf.GuardaConfiguracion('pass', passw)
		self.frmParent.conf.GuardaConfiguracion('dbname', dbname)
		self.frmParent.conf.GuardaConfiguracion('dbtype', tipobd)
		self.frmParent.conf.GuardaConfiguracion('idioma', idioma)
		
		# Si la base de datos (mysql) no existe la creamos con la estructura inicial
		
		if (tipobd == 'mysql' and self.ui.chkSobreescribirDB.isOn()):
			try:
				self.dbconn.execute(str("DROP DATABASE `"+dbname+"`"))
			except:
				print "No se ha podido eliminar la base de datos "+dbname
				
			self.correctdbname = 0

		
		if (tipobd == 'mysql' and self.correctdbname == 0):
			
			try:
				sql = "CREATE DATABASE `"+dbname+"`"
				print "Intentamos crear la base de datos ("+sql+")..."
				self.dbconn.execute(str(sql))
				self.dbconn.execute(str("USE `"+dbname+"`"))
				#Abrimos el fichero sql.sql que tiene la estructura inicial de la BD
				print "Intentamos cargar la estructura desde el fichero sql.sql..."
				fsql = open('./sql.sql','r')
				buffer = fsql.read()
				fsql.close()
				sql = buffer.split(';')
				
				for sentencia in sql:
					if len(sentencia)>0:
						print "Ejecutando "+sentencia+"..."
						self.dbconn.execute(str(sentencia))

			except:
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al crear la base de datos'))
			
			
		# Ahora guardamos los datos en el fichero de configuración		
		
		self.frmParent.conf.GuardarFichero()
		
		self.frmParent.conectar()
		self.frmParent.preferencias()
		return
